//
//  CloudRoomService.h
//  CloudroomDemo
//
//  Created by youming on 2019/11/11.
//


#import "CloudRoomService.h"
#import "RecordHelper.h"
#import "YSProgressController.h"
#import "YouSelfController.h"
@interface CloudRoomService()<CloudroomHttpFileMgrCallBack, CloudroomVideoMgrCallBack>
/**
 Cordova回调ID
 */
@property (nonatomic, copy) NSString *callbackId;
@property (nonatomic, strong) MeetInfo *meetInfo; /**< 会议信息 */
@end
@implementation CloudRoomService

#pragma mark -  登录
- (void)loginCloudRoom:(CDVInvokedUrlCommand *)command
{
    [self.commandDelegate runInBackground:^{
        dispatch_async(dispatch_get_main_queue(), ^{
            //传递的数据参数
    self.callbackId=command.callbackId;
//    NSDictionary *cmdDict = (NSDictionary *)command.arguments.firstObject;
//    NSLog(@"%@",cmdDict[@"msg"]);
            
    CloudroomVideoMgr *cloudroomVideoMgr = [CloudroomVideoMgr shareInstance];
    [cloudroomVideoMgr setMgrCallback:self];

    
    RecordHelper *recordHelper = [RecordHelper shareInstance];
    [recordHelper readInfo];
    
            NSString *nickname=@"king";
    if ([NSString stringCheckEmptyOrNil:nickname]) {
        [HUDUtil hudShow:@"昵称不能为空!" delay:3 animated:YES];
        return;
    }
    // 账号
    NSString *account = recordHelper.account;
    // 密码通过 MD5 以后(小写十六位)
    NSString *pswd = recordHelper.pswd;
    // 服务器地址
    NSString *server = recordHelper.server;
    
    if ([NSString stringCheckEmptyOrNil:server]) {
        [HUDUtil hudShow:@"服务器地址不能为空!" delay:3 animated:YES];
        return;
    }
    
    if ([NSString stringCheckEmptyOrNil:account]) {
        [HUDUtil hudShow:@"账号不能为空!" delay:3 animated:YES];
        return;
    }
    
    if ([NSString stringCheckEmptyOrNil:pswd]) {
        [HUDUtil hudShow:@"密码不能为空!" delay:3 animated:YES];
        return;
    }
    
    NSString *md5Pswd = [NSString md5:recordHelper.pswd];
    
    RLog(@"server:%@ nickname:%@ account:%@ pswd:%@", server, nickname, account, md5Pswd);
    
    //CloudroomVideoMgr *cloudroomVideoMgr = [CloudroomVideoMgr shareInstance];
    LoginDat *loginData = [[LoginDat alloc] init];
    [loginData setNickName:nickname];
    [loginData setAuthAcnt:account];
    [loginData setAuthPswd:md5Pswd];
    [loginData setPrivAcnt:nickname];
    
    [recordHelper writeAccount:account pswd:pswd server:server];
    [recordHelper writeNickname:nickname];
    
    // 域名转IP
    /*
    NSString *ip_Port;
    if ([serverIP containsString:@":"]) {
        NSArray <NSString *> *strs = [serverIP componentsSeparatedByString:@":"];
        
        if ([strs count] > 1) {
            NSString *hostToIP = [self _getIPFromHostName:[strs firstObject]];
            ip_Port = [NSString stringWithFormat:@"%@:%@", hostToIP, strs[1]];
        }
        else {
            ip_Port = [self _getIPFromHostName:[strs firstObject]];
        }
    }
    else {
        ip_Port = [self _getIPFromHostName:serverIP];
    }
     
    NSLog(@"IP+Port:%@", ip_Port);
     */
    
    // 设置服务器地址
    [[CloudroomVideoSDK shareInstance] setServerAddr:server];
    
    [HUDUtil hudShowProgress:@"正在登录..." animated:YES];
    
    // 开始上传日志
//    [[CloudroomVideoSDK shareInstance] startLogReport:nickname server:@"logserver.cloudroom.com:12005"];
//
//    [[CloudroomVideoSDK shareInstance] writeLog:SDK_LOG_LEVEL_INFO message:@"登录操作"];
    
    // 发送"登录"命令
    NSString *cookie = [NSString stringWithFormat:@"%f",CFAbsoluteTimeGetCurrent()];
    [cloudroomVideoMgr login:loginData cookie:cookie];
            
        });
                            
    }];
   
}
                      
#pragma mark -  选择自助
- (void)helpYourSelf:(CDVInvokedUrlCommand *)command
{
    [self.commandDelegate runInBackground:^{
        dispatch_async(dispatch_get_main_queue(), ^{
            self.callbackId=command.callbackId;
            CloudroomHttpFileMgr *cloudroomHttpFileMgr = [CloudroomHttpFileMgr shareInstance];
            [cloudroomHttpFileMgr setHttpFileMgrCallback:self];
            
            CloudroomVideoMgr *cloudroomVideoMgr = [CloudroomVideoMgr shareInstance];
            [cloudroomVideoMgr setMgrCallback:self];
            
            RecordHelper *recordHelper = [RecordHelper shareInstance];
            NSString *subject = [NSString stringWithFormat:@"%@的会议", [recordHelper nickname]];
            NSString *cookie = [NSString stringWithFormat:@"%f", CFAbsoluteTimeGetCurrent()];
            [[CloudroomVideoMgr shareInstance] createMeeting:subject createPswd:NO cookie:cookie];
            
//            UIStoryboard *customer = [UIStoryboard storyboardWithName:@"Record" bundle:nil];
//               YSProgressController *ysProgressVC = [customer instantiateViewControllerWithIdentifier:@"YSProgressController"];
//               //[ysProgressVC setQueID:_queID];
//               //[ysProgressVC setQueName:_queName];
//               [ysProgressVC setQueID:780];
//               [ysProgressVC setQueName:@"1"];
//                   ysProgressVC.modalPresentationStyle=UIModalPresentationFullScreen;
//               if (ysProgressVC) {
//                   [self.viewController presentViewController:ysProgressVC animated:YES completion:nil];
//               }
                
                });
                                    
            }];
           
}
//#pragma mark -  开始录制
//- (void)startRecord:(CDVInvokedUrlCommand *)command
//{
//    [self.commandDelegate runInBackground:^{
//        weakify(self)
//         NSParameterAssert(self.meetInfo);
//        dispatch_async(dispatch_get_main_queue(), ^{
//         strongify(self)
//         UIStoryboard *record = [UIStoryboard storyboardWithName:@"Record" bundle:nil];
//         YouSelfController *yourselfVC = [record instantiateViewControllerWithIdentifier:@"YouSelfController"];
//         [yourselfVC setMeetInfo:sSelf.meetInfo];
//         yourselfVC.modalPresentationStyle=UIModalPresentationFullScreen;
//         if (yourselfVC) {
//             [self.viewController presentViewController:yourselfVC animated:YES completion:nil];
//         }
//        });
//
//    }];
//
//}
#pragma mark - CloudroomVideoMgrCallBack---登录代理方法
- (void)loginSuccess:(NSString *)usrID cookie:(NSString *)cookie
{
    [HUDUtil hudHiddenProgress:YES];
    CDVPluginResult* pluginResult = [CDVPluginResult resultWithStatus:CDVCommandStatus_OK messageAsDictionary:nil];
                [self.commandDelegate sendPluginResult:pluginResult callbackId:self.callbackId];
}

- (void)loginFail:(CRVIDEOSDK_ERR_DEF)sdkErr cookie:(NSString *)cookie
{
    
    [HUDUtil hudHiddenProgress:YES];
    NSString *errorMsg=@"登录失败提示信息！";
    // FIXME:概率性登录卡死不回调 added by king 20161216
    if (sdkErr == CRVIDEOSDK_NOSERVER_RSP) {
        errorMsg=@"服务器无响应!";
    }
    else if (sdkErr == CRVIDEOSDK_LOGINSTATE_ERROR) {
        errorMsg= @"登陆状态不对!" ;
        [[CloudroomVideoMgr shareInstance] logout];
    }
    else if (sdkErr == CRVIDEOSDK_ANCTPSWD_ERR) {
        errorMsg= @"帐号密码不正确!" ;
    }
    else {
        errorMsg= @"登录失败!";
    }
    [HUDUtil hudShow:errorMsg delay:3 animated:YES];
    CDVPluginResult* pluginResult = [CDVPluginResult resultWithStatus:CDVCommandStatus_ERROR messageAsDictionary:nil];
    [self.commandDelegate sendPluginResult:pluginResult callbackId:self.callbackId];
}
#pragma mark - CloudroomVideoMgrCallBack
- (void)createMeetingSuccess:(MeetInfo *)meetInfo cookie:(NSString *)cookie
{
    weakify(self)
    self.meetInfo = meetInfo;
    
//    NSParameterAssert(self.meetInfo);
   dispatch_async(dispatch_get_main_queue(), ^{
    strongify(self)
    UIStoryboard *record = [UIStoryboard storyboardWithName:@"Record" bundle:nil];
    YouSelfController *yourselfVC = [record instantiateViewControllerWithIdentifier:@"YouSelfController"];
    [yourselfVC setMeetInfo:sSelf.meetInfo];
    yourselfVC.modalPresentationStyle=UIModalPresentationFullScreen;
    if (yourselfVC) {
        [self.viewController presentViewController:yourselfVC animated:YES completion:^{
            CDVPluginResult* pluginResult = [CDVPluginResult resultWithStatus:CDVCommandStatus_OK messageAsDictionary:nil];
            [self.commandDelegate sendPluginResult:pluginResult callbackId:self.callbackId];}];
    }
   });
    
}

- (void)createMeetingFail:(CRVIDEOSDK_ERR_DEF)sdkErr cookie:(NSString *)cookie
{
    [HUDUtil hudShow:@"创建会议失败" delay:3 animated:YES];
    CDVPluginResult* pluginResult = [CDVPluginResult resultWithStatus:CDVCommandStatus_ERROR messageAsDictionary:nil];
    [self.commandDelegate sendPluginResult:pluginResult callbackId:self.callbackId];
}

// 掉线/被踢通知
- (void)lineOff:(CRVIDEOSDK_ERR_DEF)sdkErr
{
    if (sdkErr == CRVIDEOSDK_USER_BEEN_KICKOUT) { // 被踢
         [HUDUtil hudShow:@"您已被踢下线!" delay:3 animated:YES];
    }
    else { // 掉线
        [HUDUtil hudShow:@"您已掉线!" delay:3 animated:YES];
    }
}
- (void)dealloc
{
    [[CloudroomHttpFileMgr shareInstance] stopMgr];
    [[CloudroomVideoMeeting shareInstance] exitMeeting];
}
@end
